Add hroller htools personality
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 DOCPP = $(top_srcdir)/autotools/docpp
31 REPLACE_VARS_SED = autotools/replace_vars.sed
32 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34 SHELL_ENV_INIT = autotools/shell-env-init
35
36 # Note: these are automake-specific variables, and must be named after
37 # the directory + 'dir' suffix
38 clientdir = $(pkgpythondir)/client
39 hypervisordir = $(pkgpythondir)/hypervisor
40 httpdir = $(pkgpythondir)/http
41 masterddir = $(pkgpythondir)/masterd
42 confddir = $(pkgpythondir)/confd
43 rapidir = $(pkgpythondir)/rapi
44 serverdir = $(pkgpythondir)/server
45 watcherdir = $(pkgpythondir)/watcher
46 impexpddir = $(pkgpythondir)/impexpd
47 utilsdir = $(pkgpythondir)/utils
48 toolsdir = $(pkglibdir)/tools
49 iallocatorsdir = $(pkglibdir)/iallocators
50 pytoolsdir = $(pkgpythondir)/tools
51 docdir = $(datadir)/doc/$(PACKAGE)
52 myexeclibdir = $(pkglibdir)
53
54 # Delete output file if an error occurred while building it
55 .DELETE_ON_ERROR:
56
57 HTOOLS_DIRS = \
58         htools \
59         htools/Ganeti \
60         htools/Ganeti/Block \
61         htools/Ganeti/Block/Drbd \
62         htools/Ganeti/Confd \
63         htools/Ganeti/DataCollectors \
64         htools/Ganeti/HTools \
65         htools/Ganeti/HTools/Backend \
66         htools/Ganeti/HTools/Program \
67         htools/Ganeti/Query \
68         htest \
69         htest/Test \
70         htest/Test/Ganeti \
71         htest/Test/Ganeti/Block \
72         htest/Test/Ganeti/Block/Drbd \
73         htest/Test/Ganeti/Confd \
74         htest/Test/Ganeti/HTools \
75         htest/Test/Ganeti/HTools/Backend \
76         htest/Test/Ganeti/Query
77
78 DIRS = \
79         $(HTOOLS_DIRS) \
80         autotools \
81         daemons \
82         devel \
83         doc \
84         doc/examples \
85         doc/examples/gnt-debug \
86         doc/examples/hooks \
87         htest/data \
88         htest/data/rapi \
89         htest/shelltests \
90         lib \
91         lib/build \
92         lib/client \
93         lib/confd \
94         lib/http \
95         lib/hypervisor \
96         lib/impexpd \
97         lib/masterd \
98         lib/rapi \
99         lib/server \
100         lib/tools \
101         lib/utils \
102         lib/watcher \
103         man \
104         qa \
105         test \
106         test/data \
107         test/data/ovfdata \
108         test/data/ovfdata/other \
109         tools
110
111 ALL_APIDOC_HS_DIRS = \
112         $(APIDOC_HS_DIR) \
113         $(APIDOC_HS_DIR)/Ganeti \
114         $(APIDOC_HS_DIR)/Ganeti/Block \
115         $(APIDOC_HS_DIR)/Ganeti/Block/Drbd \
116         $(APIDOC_HS_DIR)/Ganeti/Confd \
117         $(APIDOC_HS_DIR)/Ganeti/DataCollectors \
118         $(APIDOC_HS_DIR)/Ganeti/HTools \
119         $(APIDOC_HS_DIR)/Ganeti/HTools/Backend \
120         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
121         $(APIDOC_HS_DIR)/Ganeti/Query
122
123 BUILDTIME_DIR_AUTOCREATE = \
124         scripts \
125         $(APIDOC_DIR) \
126         $(ALL_APIDOC_HS_DIRS) \
127         $(APIDOC_PY_DIR) \
128         $(COVERAGE_DIR) \
129         $(COVERAGE_HS_DIR) \
130         $(COVERAGE_PY_DIR) \
131         .hpc
132
133 BUILDTIME_DIRS = \
134         $(BUILDTIME_DIR_AUTOCREATE) \
135         doc/html
136
137 DIRCHECK_EXCLUDE = \
138         $(BUILDTIME_DIRS) \
139         ganeti-[0-9]*.[0-9]*.[0-9]* \
140         doc/html/_* \
141         autom4te.cache
142
143 # some helper vars
144 COVERAGE_DIR = doc/coverage
145 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
146 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
147 APIDOC_DIR = doc/api
148 APIDOC_PY_DIR = $(APIDOC_DIR)/py
149 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
150
151 MAINTAINERCLEANFILES = \
152         $(docpng) \
153         $(maninput) \
154         doc/install-quick.rst \
155         doc/news.rst \
156         doc/upgrade.rst \
157         vcs-version
158
159 maintainer-clean-local:
160         rm -rf $(BUILDTIME_DIRS)
161
162 CLEANFILES = \
163         $(addsuffix /*.py[co],$(DIRS)) \
164         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
165         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
166         $(PYTHON_BOOTSTRAP) \
167         epydoc.conf \
168         $(REPLACE_VARS_SED) \
169         $(SHELL_ENV_INIT) \
170         daemons/daemon-util \
171         daemons/ganeti-cleaner \
172         $(BUILT_EXAMPLES) \
173         doc/examples/bash_completion \
174         doc/examples/bash_completion-debug \
175         lib/_generated_rpc.py \
176         $(man_MANS) \
177         $(manhtml) \
178         tools/kvm-ifup \
179         tools/vcluster-setup \
180         stamp-directories \
181         stamp-srclinks \
182         $(nodist_pkgpython_PYTHON) \
183         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
184         $(HS_BUILT_TEST_HELPERS) \
185         htools/ganeti-confd \
186         .hpc/*.mix htools/*.tix htest/*.tix \
187         doc/hs-lint.html
188
189 GENERATED_FILES = \
190         $(built_base_sources) \
191         $(BUILT_PYTHON_SOURCES) \
192         $(PYTHON_BOOTSTRAP)
193
194 HTOOLS_GENERATED_FILES =
195 if WANT_HTOOLS
196 HTOOLS_GENERATED_FILES += $(HS_PROGS)
197 if ENABLE_CONFD
198 HTOOLS_GENERATED_FILES += htools/hconfd htools/ganeti-confd
199 endif
200 endif
201
202 built_base_sources = \
203         stamp-directories \
204         stamp-srclinks
205
206 built_python_base_sources = \
207         lib/_autoconf.py \
208         lib/_vcsversion.py
209
210 BUILT_PYTHON_SOURCES = \
211         $(built_python_base_sources) \
212         lib/_generated_rpc.py
213
214 # Generating the RPC wrappers depends on many things, so make sure
215 # it's built at the end of the built sources
216 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
217
218 # these are all built from the underlying %.in sources
219 BUILT_EXAMPLES = \
220         doc/examples/ganeti-kvm-poweroff.initd \
221         doc/examples/ganeti.cron \
222         doc/examples/ganeti.initd \
223         doc/examples/ganeti-master-role.ocf \
224         doc/examples/ganeti-node-role.ocf \
225         doc/examples/gnt-config-backup \
226         doc/examples/hooks/ipsec
227
228 nodist_pkgpython_PYTHON = \
229         $(BUILT_PYTHON_SOURCES)
230
231 noinst_PYTHON = \
232         lib/build/__init__.py \
233         lib/build/shell_example_lexer.py \
234         lib/build/sphinx_ext.py
235
236 pkgpython_PYTHON = \
237         lib/__init__.py \
238         lib/asyncnotifier.py \
239         lib/backend.py \
240         lib/bdev.py \
241         lib/bootstrap.py \
242         lib/cli.py \
243         lib/cmdlib.py \
244         lib/compat.py \
245         lib/config.py \
246         lib/constants.py \
247         lib/daemon.py \
248         lib/errors.py \
249         lib/ht.py \
250         lib/jqueue.py \
251         lib/jstore.py \
252         lib/locking.py \
253         lib/luxi.py \
254         lib/mcpu.py \
255         lib/netutils.py \
256         lib/objects.py \
257         lib/objectutils.py \
258         lib/opcodes.py \
259         lib/ovf.py \
260         lib/pathutils.py \
261         lib/qlang.py \
262         lib/query.py \
263         lib/rpc.py \
264         lib/rpc_defs.py \
265         lib/runtime.py \
266         lib/serializer.py \
267         lib/ssconf.py \
268         lib/ssh.py \
269         lib/storage.py \
270         lib/uidpool.py \
271         lib/vcluster.py \
272         lib/network.py \
273         lib/workerpool.py
274
275 client_PYTHON = \
276         lib/client/__init__.py \
277         lib/client/gnt_backup.py \
278         lib/client/gnt_cluster.py \
279         lib/client/gnt_debug.py \
280         lib/client/gnt_group.py \
281         lib/client/gnt_instance.py \
282         lib/client/gnt_job.py \
283         lib/client/gnt_node.py \
284         lib/client/gnt_network.py \
285         lib/client/gnt_os.py
286
287 hypervisor_PYTHON = \
288         lib/hypervisor/__init__.py \
289         lib/hypervisor/hv_base.py \
290         lib/hypervisor/hv_chroot.py \
291         lib/hypervisor/hv_fake.py \
292         lib/hypervisor/hv_kvm.py \
293         lib/hypervisor/hv_lxc.py \
294         lib/hypervisor/hv_xen.py
295
296 rapi_PYTHON = \
297         lib/rapi/__init__.py \
298         lib/rapi/baserlib.py \
299         lib/rapi/client.py \
300         lib/rapi/client_utils.py \
301         lib/rapi/connector.py \
302         lib/rapi/rlib2.py \
303         lib/rapi/testutils.py
304
305 http_PYTHON = \
306         lib/http/__init__.py \
307         lib/http/auth.py \
308         lib/http/client.py \
309         lib/http/server.py
310
311 confd_PYTHON = \
312         lib/confd/__init__.py \
313         lib/confd/client.py
314
315 masterd_PYTHON = \
316         lib/masterd/__init__.py \
317         lib/masterd/iallocator.py \
318         lib/masterd/instance.py
319
320 impexpd_PYTHON = \
321         lib/impexpd/__init__.py
322
323 watcher_PYTHON = \
324         lib/watcher/__init__.py \
325         lib/watcher/nodemaint.py \
326         lib/watcher/state.py
327
328 server_PYTHON = \
329         lib/server/__init__.py \
330         lib/server/masterd.py \
331         lib/server/noded.py \
332         lib/server/rapi.py
333
334 pytools_PYTHON = \
335         lib/tools/__init__.py \
336         lib/tools/ensure_dirs.py \
337         lib/tools/node_cleanup.py \
338         lib/tools/node_daemon_setup.py \
339         lib/tools/prepare_node_join.py
340
341 utils_PYTHON = \
342         lib/utils/__init__.py \
343         lib/utils/algo.py \
344         lib/utils/filelock.py \
345         lib/utils/hash.py \
346         lib/utils/io.py \
347         lib/utils/log.py \
348         lib/utils/mlock.py \
349         lib/utils/nodesetup.py \
350         lib/utils/process.py \
351         lib/utils/retry.py \
352         lib/utils/text.py \
353         lib/utils/wrapper.py \
354         lib/utils/x509.py
355
356 docrst = \
357         doc/admin.rst \
358         doc/cluster-merge.rst \
359         doc/design-2.0.rst \
360         doc/design-2.1.rst \
361         doc/design-2.2.rst \
362         doc/design-2.3.rst \
363         doc/design-2.4.rst \
364         doc/design-2.5.rst \
365         doc/design-2.6.rst \
366         doc/design-2.7.rst \
367         doc/design-autorepair.rst \
368         doc/design-bulk-create.rst \
369         doc/design-chained-jobs.rst \
370         doc/design-cpu-pinning.rst \
371         doc/design-draft.rst \
372         doc/design-htools-2.3.rst \
373         doc/design-http-server.rst \
374         doc/design-impexp2.rst \
375         doc/design-lu-generated-jobs.rst \
376         doc/design-linuxha.rst \
377         doc/design-multi-reloc.rst \
378         doc/design-network.rst \
379         doc/design-node-add.rst \
380         doc/design-oob.rst \
381         doc/design-ovf-support.rst \
382         doc/design-opportunistic-locking.rst \
383         doc/design-partitioned.rst \
384         doc/design-query-splitting.rst \
385         doc/design-query2.rst \
386         doc/design-remote-commands.rst \
387         doc/design-resource-model.rst \
388         doc/design-shared-storage.rst \
389         doc/design-monitoring-agent.rst \
390         doc/design-virtual-clusters.rst \
391         doc/design-x509-ca.rst \
392         doc/devnotes.rst \
393         doc/glossary.rst \
394         doc/hooks.rst \
395         doc/iallocator.rst \
396         doc/index.rst \
397         doc/install-quick.rst \
398         doc/install.rst \
399         doc/locking.rst \
400         doc/move-instance.rst \
401         doc/news.rst \
402         doc/ovfconverter.rst \
403         doc/rapi.rst \
404         doc/security.rst \
405         doc/upgrade.rst \
406         doc/virtual-cluster.rst \
407         doc/walkthrough.rst
408
409 HS_PROGS = htools/htools htools/mon-collector
410 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck hroller
411 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
412
413 HS_ALL_PROGS = \
414         $(HS_PROGS) \
415         htest/hpc-htools \
416         htest/hpc-mon-collector \
417         htest/test \
418         htools/hconfd \
419         htools/rpc-test
420
421 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
422 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=htest/%) htest/hail
423
424 HFLAGS = \
425         -O -Wall -Werror -ihtools \
426         -fwarn-monomorphism-restriction \
427         -fwarn-tabs \
428         $(GHC_BYVERSION_FLAGS)
429
430 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
431 HEXTRA =
432 # internal extra flags (used for htest/test mainly)
433 HEXTRA_INT =
434 # exclude options for coverage reports
435 HPCEXCL = --exclude Main \
436         --exclude Ganeti.Constants \
437         --exclude Ganeti.HTools.QC \
438         --exclude Ganeti.THH \
439         --exclude Ganeti.Version \
440         --exclude Test.Ganeti.Attoparsec \
441         --exclude Test.Ganeti.TestCommon \
442         --exclude Test.Ganeti.TestHTools \
443         --exclude Test.Ganeti.TestHelper \
444         --exclude Test.Ganeti.TestImports \
445         $(patsubst htools.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
446
447 HS_LIB_SRCS = \
448         htools/Ganeti/Block/Drbd/Types.hs \
449         htools/Ganeti/Block/Drbd/Parser.hs \
450         htools/Ganeti/BasicTypes.hs \
451         htools/Ganeti/Common.hs \
452         htools/Ganeti/Compat.hs \
453         htools/Ganeti/Confd/Server.hs \
454         htools/Ganeti/Confd/Types.hs \
455         htools/Ganeti/Confd/Utils.hs \
456         htools/Ganeti/Config.hs \
457         htools/Ganeti/Daemon.hs \
458         htools/Ganeti/DataCollectors/CLI.hs \
459         htools/Ganeti/DataCollectors/Drbd.hs \
460         htools/Ganeti/DataCollectors/Program.hs \
461         htools/Ganeti/Errors.hs \
462         htools/Ganeti/HTools/Backend/IAlloc.hs \
463         htools/Ganeti/HTools/Backend/Luxi.hs \
464         htools/Ganeti/HTools/Backend/Rapi.hs \
465         htools/Ganeti/HTools/Backend/Simu.hs \
466         htools/Ganeti/HTools/Backend/Text.hs \
467         htools/Ganeti/HTools/CLI.hs \
468         htools/Ganeti/HTools/Cluster.hs \
469         htools/Ganeti/HTools/Container.hs \
470         htools/Ganeti/HTools/ExtLoader.hs \
471         htools/Ganeti/HTools/Graph.hs \
472         htools/Ganeti/HTools/Group.hs \
473         htools/Ganeti/HTools/Instance.hs \
474         htools/Ganeti/HTools/Loader.hs \
475         htools/Ganeti/HTools/Node.hs \
476         htools/Ganeti/HTools/PeerMap.hs \
477         htools/Ganeti/HTools/Program.hs \
478         htools/Ganeti/HTools/Program/Hail.hs \
479         htools/Ganeti/HTools/Program/Hbal.hs \
480         htools/Ganeti/HTools/Program/Hcheck.hs \
481         htools/Ganeti/HTools/Program/Hinfo.hs \
482         htools/Ganeti/HTools/Program/Hscan.hs \
483         htools/Ganeti/HTools/Program/Hspace.hs \
484         htools/Ganeti/HTools/Program/Hroller.hs \
485         htools/Ganeti/HTools/Types.hs \
486         htools/Ganeti/Hash.hs \
487         htools/Ganeti/JQueue.hs \
488         htools/Ganeti/JSON.hs \
489         htools/Ganeti/Jobs.hs \
490         htools/Ganeti/Logging.hs \
491         htools/Ganeti/Luxi.hs \
492         htools/Ganeti/Network.hs \
493         htools/Ganeti/Objects.hs \
494         htools/Ganeti/OpCodes.hs \
495         htools/Ganeti/OpParams.hs \
496         htools/Ganeti/Path.hs \
497         htools/Ganeti/Query/Common.hs \
498         htools/Ganeti/Query/Filter.hs \
499         htools/Ganeti/Query/Group.hs \
500         htools/Ganeti/Query/Job.hs \
501         htools/Ganeti/Query/Language.hs \
502         htools/Ganeti/Query/Node.hs \
503         htools/Ganeti/Query/Query.hs \
504         htools/Ganeti/Query/Server.hs \
505         htools/Ganeti/Query/Types.hs \
506         htools/Ganeti/Rpc.hs \
507         htools/Ganeti/Runtime.hs \
508         htools/Ganeti/Ssconf.hs \
509         htools/Ganeti/THH.hs \
510         htools/Ganeti/Types.hs \
511         htools/Ganeti/Utils.hs
512
513 HS_TEST_SRCS = \
514         htest/Test/Ganeti/Attoparsec.hs \
515         htest/Test/Ganeti/BasicTypes.hs \
516         htest/Test/Ganeti/Block/Drbd/Parser.hs \
517         htest/Test/Ganeti/Block/Drbd/Types.hs \
518         htest/Test/Ganeti/Common.hs \
519         htest/Test/Ganeti/Confd/Types.hs \
520         htest/Test/Ganeti/Confd/Utils.hs \
521         htest/Test/Ganeti/Daemon.hs \
522         htest/Test/Ganeti/Errors.hs \
523         htest/Test/Ganeti/HTools/Backend/Simu.hs \
524         htest/Test/Ganeti/HTools/Backend/Text.hs \
525         htest/Test/Ganeti/HTools/CLI.hs \
526         htest/Test/Ganeti/HTools/Cluster.hs \
527         htest/Test/Ganeti/HTools/Container.hs \
528         htest/Test/Ganeti/HTools/Graph.hs \
529         htest/Test/Ganeti/HTools/Instance.hs \
530         htest/Test/Ganeti/HTools/Loader.hs \
531         htest/Test/Ganeti/HTools/Node.hs \
532         htest/Test/Ganeti/HTools/PeerMap.hs \
533         htest/Test/Ganeti/HTools/Types.hs \
534         htest/Test/Ganeti/JSON.hs \
535         htest/Test/Ganeti/Jobs.hs \
536         htest/Test/Ganeti/JQueue.hs \
537         htest/Test/Ganeti/Luxi.hs \
538         htest/Test/Ganeti/Network.hs \
539         htest/Test/Ganeti/Objects.hs \
540         htest/Test/Ganeti/OpCodes.hs \
541         htest/Test/Ganeti/Query/Filter.hs \
542         htest/Test/Ganeti/Query/Language.hs \
543         htest/Test/Ganeti/Query/Query.hs \
544         htest/Test/Ganeti/Rpc.hs \
545         htest/Test/Ganeti/Ssconf.hs \
546         htest/Test/Ganeti/THH.hs \
547         htest/Test/Ganeti/TestCommon.hs \
548         htest/Test/Ganeti/TestHTools.hs \
549         htest/Test/Ganeti/TestHelper.hs \
550         htest/Test/Ganeti/Types.hs \
551         htest/Test/Ganeti/Utils.hs
552
553 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
554
555 HS_BUILT_SRCS = \
556         htest/Test/Ganeti/TestImports.hs \
557         htools/Ganeti/Constants.hs \
558         htools/Ganeti/Version.hs
559 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
560
561 $(RUN_IN_TEMPDIR): | stamp-directories
562
563 # Note: we use here an order-only prerequisite, as the contents of
564 # _autoconf.py are not actually influencing the html build output: it
565 # has to exist in order for the sphinx module to be loaded
566 # successfully, but we certainly don't want the docs to be rebuilt if
567 # it changes
568 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
569         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
570         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
571         | $(BUILT_PYTHON_SOURCES)
572         @test -n "$(SPHINX)" || \
573             { echo 'sphinx-build' not found during configure; exit 1; }
574         @mkdir_p@ $(dir $@)
575         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
576             -d . \
577             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
578             -D release="$(PACKAGE_VERSION)" \
579             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
580         rm -f doc/html/.buildinfo doc/html/objects.inv
581         touch $@
582
583 doc/html: doc/html/index.html
584
585 doc/install-quick.rst: INSTALL
586 doc/news.rst: NEWS
587 doc/upgrade.rst: UPGRADE
588
589 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
590         set -e; \
591         { echo '.. This file is automatically updated at build time from $<.'; \
592           echo '.. Do not edit.'; \
593           echo; \
594           cat $<; \
595         } > $@
596
597 docdot = \
598         doc/arch-2.0.dot \
599         doc/design-2.1-lock-acquire.dot \
600         doc/design-2.1-lock-release.dot
601
602 docpng = $(patsubst %.dot,%.png,$(docdot))
603
604 # Things to build but not to install (add it to EXTRA_DIST if it should be
605 # distributed)
606 noinst_DATA = \
607         doc/html \
608         $(BUILT_EXAMPLES) \
609         doc/examples/bash_completion \
610         doc/examples/bash_completion-debug \
611         $(manhtml)
612
613 gnt_scripts = \
614         scripts/gnt-backup \
615         scripts/gnt-cluster \
616         scripts/gnt-debug \
617         scripts/gnt-group \
618         scripts/gnt-instance \
619         scripts/gnt-job \
620         scripts/gnt-network \
621         scripts/gnt-node \
622         scripts/gnt-os
623
624 PYTHON_BOOTSTRAP_SBIN = \
625         daemons/ganeti-masterd \
626         daemons/ganeti-noded \
627         daemons/ganeti-rapi \
628         daemons/ganeti-watcher \
629         $(gnt_scripts)
630
631 PYTHON_BOOTSTRAP = \
632         $(PYTHON_BOOTSTRAP_SBIN) \
633         tools/ensure-dirs \
634         tools/node-cleanup \
635         tools/node-daemon-setup \
636         tools/prepare-node-join
637
638 qa_scripts = \
639         qa/__init__.py \
640         qa/ganeti-qa.py \
641         qa/qa_cluster.py \
642         qa/qa_config.py \
643         qa/qa_daemon.py \
644         qa/qa_env.py \
645         qa/qa_error.py \
646         qa/qa_group.py \
647         qa/qa_instance.py \
648         qa/qa_job.py \
649         qa/qa_node.py \
650         qa/qa_os.py \
651         qa/qa_rapi.py \
652         qa/qa_tags.py \
653         qa/qa_utils.py
654
655 bin_SCRIPTS =
656 if WANT_HTOOLS
657 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
658 install-exec-hook:
659         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
660 # FIXME: this is a hardcoded logic, instead of auto-resolving
661         $(LN_S) -f ../../../bin/htools \
662           $(DESTDIR)$(iallocatorsdir)/hail
663         for role in $(HS_BIN_ROLES); do \
664           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
665         done
666 endif
667
668 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
669         @if [ "$(notdir $@)" = "test" ] && [ "$(HTOOLS_NODEV)" ]; then \
670           echo "Error: cannot run unittests without the development" \
671                " libraries (see devnotes.rst)" 1>&2; \
672           exit 1; \
673         fi
674         @rm -f $(notdir $@).tix
675         $(GHC) --make \
676           $(HFLAGS) \
677           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
678           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
679           $(HEXTRA) $(HEXTRA_INT) $@
680         @touch "$@"
681
682 # for the htest/test binary, we need to enable profiling/coverage
683 htest/test: HEXTRA_INT=-fhpc -ihtest
684
685 # we compile the hpc-htools binary with the program coverage
686 htest/hpc-htools: HEXTRA_INT=-fhpc
687
688 # we compile the hpc-mon-collector binary with the program coverage
689 htest/hpc-mon-collector: HEXTRA_INT=-fhpc
690
691 # test dependency
692 htest/offline-tests.sh: htest/hpc-htools htest/hpc-mon-collector
693
694 # rules for building profiling-enabled versions of the haskell
695 # programs: hs-prof does the full two-step build, whereas
696 # hs-prof-quick does only the final rebuild (hs-prof must have been
697 # run before)
698 .PHONY: hs-prof hs-prof-quick
699 hs-prof:
700         @if [ -z "$(TARGET)" ]; then \
701           echo "You need to define TARGET when running this rule" 1>&2; \
702           exit 1; \
703         fi
704         $(MAKE) $(AM_MAKEFLAGS) clean
705         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
706         rm -f $(HS_ALL_PROGS)
707         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
708
709 hs-prof-quick:
710         @if [ -z "$(TARGET)" ]; then \
711           echo "You need to define TARGET when running this rule" 1>&2; \
712           exit 1; \
713         fi
714         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
715
716 dist_sbin_SCRIPTS = \
717         tools/ganeti-listrunner
718
719 nodist_sbin_SCRIPTS = \
720         $(PYTHON_BOOTSTRAP_SBIN) \
721         daemons/ganeti-cleaner
722
723 if ENABLE_CONFD
724 htools/ganeti-confd: htools/hconfd
725         cp -f $< $@
726
727 nodist_sbin_SCRIPTS += htools/ganeti-confd
728 endif
729
730 python_scripts = \
731         tools/burnin \
732         tools/cfgshell \
733         tools/cfgupgrade \
734         tools/cfgupgrade12 \
735         tools/cluster-merge \
736         tools/confd-client \
737         tools/fmtjson \
738         tools/lvmstrap \
739         tools/move-instance \
740         tools/ovfconverter \
741         tools/sanitize-config
742
743 dist_tools_SCRIPTS = \
744         $(python_scripts) \
745         tools/kvm-console-wrapper \
746         tools/master-ip-setup \
747         tools/xen-console-wrapper
748
749 nodist_tools_python_scripts = \
750         tools/node-cleanup
751
752 nodist_tools_SCRIPTS = \
753         $(nodist_tools_python_scripts) \
754         tools/vcluster-setup
755
756 pkglib_python_scripts = \
757         daemons/import-export \
758         tools/check-cert-expired
759
760 nodist_pkglib_python_scripts = \
761         tools/ensure-dirs \
762         tools/node-daemon-setup \
763         tools/prepare-node-join
764
765 myexeclib_SCRIPTS = \
766         daemons/daemon-util \
767         tools/kvm-ifup \
768         $(pkglib_python_scripts) \
769         htools/mon-collector
770
771 nodist_myexeclib_SCRIPTS = \
772         $(nodist_pkglib_python_scripts)
773
774 EXTRA_DIST = \
775         NEWS \
776         UPGRADE \
777         epydoc.conf.in \
778         pylintrc \
779         autotools/build-bash-completion \
780         autotools/build-rpc \
781         autotools/check-header \
782         autotools/check-imports \
783         autotools/check-man-dashes \
784         autotools/check-man-warnings \
785         autotools/check-news \
786         autotools/check-python-code \
787         autotools/check-tar \
788         autotools/check-version \
789         autotools/convert-constants \
790         autotools/docpp \
791         autotools/gen-coverage \
792         autotools/testrunner \
793         autotools/wrong-hardcoded-paths \
794         $(RUN_IN_TEMPDIR) \
795         daemons/daemon-util.in \
796         daemons/ganeti-cleaner.in \
797         $(pkglib_python_scripts) \
798         devel/upload \
799         tools/kvm-ifup.in \
800         tools/vcluster-setup.in \
801         $(docdot) \
802         $(docpng) \
803         $(docrst) \
804         doc/conf.py \
805         doc/html \
806         $(BUILT_EXAMPLES:%=%.in) \
807         doc/examples/ganeti.default \
808         doc/examples/ganeti.default-debug \
809         doc/examples/hooks/ethers \
810         doc/examples/gnt-debug/README \
811         doc/examples/gnt-debug/delay0.json \
812         doc/examples/gnt-debug/delay50.json \
813         test/lockperf.py \
814         test/testutils.py \
815         test/mocks.py \
816         $(dist_TESTS) \
817         $(TEST_FILES) \
818         man/footer.rst \
819         $(manrst) \
820         $(maninput) \
821         qa/qa-sample.json \
822         $(qa_scripts) \
823         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
824         $(HS_PROG_SRCS) \
825         htools/lint-hints.hs \
826         htest/cli-tests-defs.sh \
827         htest/offline-test.sh \
828         .ghci
829
830 man_MANS = \
831         man/ganeti-cleaner.8 \
832         man/ganeti-confd.8 \
833         man/ganeti-listrunner.8 \
834         man/ganeti-masterd.8 \
835         man/ganeti-noded.8 \
836         man/ganeti-os-interface.7 \
837         man/ganeti-rapi.8 \
838         man/ganeti-watcher.8 \
839         man/ganeti.7 \
840         man/gnt-backup.8 \
841         man/gnt-cluster.8 \
842         man/gnt-debug.8 \
843         man/gnt-group.8 \
844         man/gnt-network.8 \
845         man/gnt-instance.8 \
846         man/gnt-job.8 \
847         man/gnt-node.8 \
848         man/gnt-os.8 \
849         man/hail.1 \
850         man/hbal.1 \
851         man/hcheck.1 \
852         man/hinfo.1 \
853         man/hscan.1 \
854         man/hspace.1 \
855         man/hroller.1 \
856         man/htools.1 \
857         man/mon-collector.7
858
859 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
860 manhtml = $(patsubst %.rst,%.html,$(manrst))
861 mangen = $(patsubst %.rst,%.gen,$(manrst))
862 maninput = \
863         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
864         $(patsubst %.html,%.html.in,$(manhtml)) \
865         man/footer.man man/footer.html $(mangen)
866
867 TEST_FILES = \
868         htest/data/common-suffix.data \
869         htest/data/hail-alloc-drbd.json \
870         htest/data/hail-change-group.json \
871         htest/data/hail-invalid-reloc.json \
872         htest/data/hail-node-evac.json \
873         htest/data/hail-reloc-drbd.json \
874         htest/data/hbal-excl-tags.data \
875         htest/data/hbal-split-insts.data \
876         htest/data/invalid-node.data \
877         htest/data/missing-resources.data \
878         htest/data/rapi/groups.json \
879         htest/data/rapi/info.json \
880         htest/data/rapi/instances.json \
881         htest/data/rapi/nodes.json \
882         htest/shelltests/htools-balancing.test \
883         htest/shelltests/htools-basic.test \
884         htest/shelltests/htools-dynutil.test \
885         htest/shelltests/htools-excl.test \
886         htest/shelltests/htools-hail.test \
887         htest/shelltests/htools-hspace.test \
888         htest/shelltests/htools-invalid.test \
889         htest/shelltests/htools-multi-group.test \
890         htest/shelltests/htools-no-backend.test \
891         htest/shelltests/htools-rapi.test \
892         htest/shelltests/htools-single-group.test \
893         htest/shelltests/htools-text-backend.test \
894         htest/shelltests/htools-mon-collector.test \
895         test/data/bdev-drbd-8.0.txt \
896         test/data/bdev-drbd-8.3.txt \
897         test/data/bdev-drbd-disk.txt \
898         test/data/bdev-drbd-net-ip4.txt \
899         test/data/bdev-drbd-net-ip6.txt \
900         test/data/cert1.pem \
901         test/data/cert2.pem \
902         test/data/ip-addr-show-dummy0.txt \
903         test/data/ip-addr-show-lo-ipv4.txt \
904         test/data/ip-addr-show-lo-ipv6.txt \
905         test/data/ip-addr-show-lo-oneline-ipv4.txt \
906         test/data/ip-addr-show-lo-oneline-ipv6.txt \
907         test/data/ip-addr-show-lo-oneline.txt \
908         test/data/ip-addr-show-lo.txt \
909         test/data/kvm_0.12.5_help.txt \
910         test/data/kvm_0.15.90_help.txt \
911         test/data/kvm_0.9.1_help.txt \
912         test/data/kvm_1.0_help.txt \
913         test/data/ovfdata/compr_disk.vmdk.gz \
914         test/data/ovfdata/config.ini \
915         test/data/ovfdata/corrupted_resources.ovf \
916         test/data/ovfdata/empty.ini \
917         test/data/ovfdata/empty.ovf \
918         test/data/ovfdata/ganeti.mf \
919         test/data/ovfdata/ganeti.ovf \
920         test/data/ovfdata/gzip_disk.ovf \
921         test/data/ovfdata/new_disk.vmdk \
922         test/data/ovfdata/no_disk.ini \
923         test/data/ovfdata/no_disk_in_ref.ovf \
924         test/data/ovfdata/no_os.ini \
925         test/data/ovfdata/no_ovf.ova \
926         test/data/ovfdata/other/rawdisk.raw \
927         test/data/ovfdata/ova.ova \
928         test/data/ovfdata/rawdisk.raw \
929         test/data/ovfdata/second_disk.vmdk \
930         test/data/ovfdata/unsafe_path.ini \
931         test/data/ovfdata/virtualbox.ovf \
932         test/data/ovfdata/wrong_config.ini \
933         test/data/ovfdata/wrong_extension.ovd \
934         test/data/ovfdata/wrong_manifest.mf \
935         test/data/ovfdata/wrong_manifest.ovf \
936         test/data/ovfdata/wrong_ova.ova \
937         test/data/ovfdata/wrong_xml.ovf \
938         test/data/proc_drbd8.txt \
939         test/data/proc_drbd80-emptyline.txt \
940         test/data/proc_drbd83.txt \
941         test/data/proc_drbd83_sync.txt \
942         test/data/proc_drbd83_sync_want.txt \
943         test/data/proc_drbd83_sync_krnl2.6.39.txt \
944         test/data/sys_drbd_usermode_helper.txt \
945         test/data/vgreduce-removemissing-2.02.02.txt \
946         test/data/vgreduce-removemissing-2.02.66-fail.txt \
947         test/data/vgreduce-removemissing-2.02.66-ok.txt \
948         test/data/vgs-missing-pvs-2.02.02.txt \
949         test/data/vgs-missing-pvs-2.02.66.txt \
950         test/ganeti-cli.test \
951         test/gnt-cli.test \
952         test/import-export_unittest-helper
953
954 python_tests = \
955         doc/examples/rapi_testutils.py \
956         test/cfgupgrade_unittest.py \
957         test/docs_unittest.py \
958         test/ganeti.asyncnotifier_unittest.py \
959         test/ganeti.backend_unittest-runasroot.py \
960         test/ganeti.backend_unittest.py \
961         test/ganeti.bdev_unittest.py \
962         test/ganeti.cli_unittest.py \
963         test/ganeti.client.gnt_cluster_unittest.py \
964         test/ganeti.client.gnt_instance_unittest.py \
965         test/ganeti.client.gnt_job_unittest.py \
966         test/ganeti.cmdlib_unittest.py \
967         test/ganeti.compat_unittest.py \
968         test/ganeti.confd.client_unittest.py \
969         test/ganeti.config_unittest.py \
970         test/ganeti.constants_unittest.py \
971         test/ganeti.daemon_unittest.py \
972         test/ganeti.errors_unittest.py \
973         test/ganeti.hooks_unittest.py \
974         test/ganeti.ht_unittest.py \
975         test/ganeti.http_unittest.py \
976         test/ganeti.hypervisor.hv_chroot_unittest.py \
977         test/ganeti.hypervisor.hv_fake_unittest.py \
978         test/ganeti.hypervisor.hv_kvm_unittest.py \
979         test/ganeti.hypervisor.hv_lxc_unittest.py \
980         test/ganeti.hypervisor.hv_xen_unittest.py \
981         test/ganeti.hypervisor_unittest.py \
982         test/ganeti.impexpd_unittest.py \
983         test/ganeti.jqueue_unittest.py \
984         test/ganeti.jstore_unittest.py \
985         test/ganeti.locking_unittest.py \
986         test/ganeti.luxi_unittest.py \
987         test/ganeti.masterd.iallocator_unittest.py \
988         test/ganeti.masterd.instance_unittest.py \
989         test/ganeti.mcpu_unittest.py \
990         test/ganeti.netutils_unittest.py \
991         test/ganeti.objects_unittest.py \
992         test/ganeti.objectutils_unittest.py \
993         test/ganeti.opcodes_unittest.py \
994         test/ganeti.ovf_unittest.py \
995         test/ganeti.qlang_unittest.py \
996         test/ganeti.query_unittest.py \
997         test/ganeti.rapi.baserlib_unittest.py \
998         test/ganeti.rapi.client_unittest.py \
999         test/ganeti.rapi.resources_unittest.py \
1000         test/ganeti.rapi.rlib2_unittest.py \
1001         test/ganeti.rapi.testutils_unittest.py \
1002         test/ganeti.rpc_unittest.py \
1003         test/ganeti.runtime_unittest.py \
1004         test/ganeti.serializer_unittest.py \
1005         test/ganeti.server.rapi_unittest.py \
1006         test/ganeti.ssconf_unittest.py \
1007         test/ganeti.ssh_unittest.py \
1008         test/ganeti.storage_unittest.py \
1009         test/ganeti.tools.ensure_dirs_unittest.py \
1010         test/ganeti.tools.node_daemon_setup_unittest.py \
1011         test/ganeti.tools.prepare_node_join_unittest.py \
1012         test/ganeti.uidpool_unittest.py \
1013         test/ganeti.utils.algo_unittest.py \
1014         test/ganeti.utils.filelock_unittest.py \
1015         test/ganeti.utils.hash_unittest.py \
1016         test/ganeti.utils.io_unittest-runasroot.py \
1017         test/ganeti.utils.io_unittest.py \
1018         test/ganeti.utils.log_unittest.py \
1019         test/ganeti.utils.mlock_unittest.py \
1020         test/ganeti.utils.nodesetup_unittest.py \
1021         test/ganeti.utils.process_unittest.py \
1022         test/ganeti.utils.retry_unittest.py \
1023         test/ganeti.utils.text_unittest.py \
1024         test/ganeti.utils.wrapper_unittest.py \
1025         test/ganeti.utils.x509_unittest.py \
1026         test/ganeti.utils_unittest.py \
1027         test/ganeti.vcluster_unittest.py \
1028         test/ganeti.workerpool_unittest.py \
1029         test/pycurl_reset_unittest.py \
1030         test/qa.qa_config_unittest.py \
1031         test/tempfile_fork_unittest.py
1032
1033 haskell_tests = htest/test
1034
1035 dist_TESTS = \
1036         test/check-cert-expired_unittest.bash \
1037         test/daemon-util_unittest.bash \
1038         test/ganeti-cleaner_unittest.bash \
1039         test/import-export_unittest.bash \
1040         test/cli-test.bash \
1041         test/bash_completion.bash \
1042         $(python_tests)
1043
1044 nodist_TESTS =
1045 check_SCRIPTS =
1046
1047 if WANT_HTOOLSTESTS
1048 nodist_TESTS += $(haskell_tests)
1049 dist_TESTS += htest/offline-test.sh
1050 check_SCRIPTS += \
1051         htest/hpc-htools \
1052         htest/hpc-mon-collector \
1053         $(HS_BUILT_TEST_HELPERS)
1054 endif
1055
1056 TESTS = $(dist_TESTS) $(nodist_TESTS)
1057
1058 # Environment for all tests
1059 PLAIN_TESTS_ENVIRONMENT = \
1060         PYTHONPATH=. \
1061         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1062         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1063         $(RUN_IN_TEMPDIR)
1064
1065 # Environment for tests run by automake
1066 TESTS_ENVIRONMENT = \
1067         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1068
1069 all_python_code = \
1070         $(dist_sbin_SCRIPTS) \
1071         $(python_scripts) \
1072         $(pkglib_python_scripts) \
1073         $(nodist_pkglib_python_scripts) \
1074         $(nodist_tools_python_scripts) \
1075         $(python_tests) \
1076         $(pkgpython_PYTHON) \
1077         $(client_PYTHON) \
1078         $(hypervisor_PYTHON) \
1079         $(rapi_PYTHON) \
1080         $(server_PYTHON) \
1081         $(pytools_PYTHON) \
1082         $(http_PYTHON) \
1083         $(confd_PYTHON) \
1084         $(masterd_PYTHON) \
1085         $(impexpd_PYTHON) \
1086         $(utils_PYTHON) \
1087         $(watcher_PYTHON) \
1088         $(noinst_PYTHON) \
1089         $(qa_scripts)
1090
1091 srclink_files = \
1092         man/footer.rst \
1093         test/check-cert-expired_unittest.bash \
1094         test/daemon-util_unittest.bash \
1095         test/ganeti-cleaner_unittest.bash \
1096         test/import-export_unittest.bash \
1097         test/cli-test.bash \
1098         test/bash_completion.bash \
1099         htest/offline-test.sh \
1100         htest/cli-tests-defs.sh \
1101         $(all_python_code) \
1102         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS)
1103
1104 check_python_code = \
1105         $(BUILD_BASH_COMPLETION) \
1106         $(CHECK_IMPORTS) \
1107         $(CHECK_HEADER) \
1108         $(DOCPP) \
1109         $(all_python_code)
1110
1111 lint_python_code = \
1112         ganeti \
1113         ganeti/http/server.py \
1114         $(dist_sbin_SCRIPTS) \
1115         $(python_scripts) \
1116         $(pkglib_python_scripts) \
1117         $(BUILD_BASH_COMPLETION) \
1118         $(CHECK_IMPORTS) \
1119         $(CHECK_HEADER) \
1120         $(DOCPP) \
1121         $(PYTHON_BOOTSTRAP)
1122
1123 standalone_python_modules = \
1124         lib/rapi/client.py \
1125         tools/ganeti-listrunner
1126
1127 pep8_python_code = \
1128         ganeti \
1129         ganeti/http/server.py \
1130         $(dist_sbin_SCRIPTS) \
1131         $(python_scripts) \
1132         $(pkglib_python_scripts) \
1133         $(BUILD_BASH_COMPLETION) \
1134         $(CHECK_HEADER) \
1135         $(DOCPP) \
1136         $(PYTHON_BOOTSTRAP) \
1137         qa
1138
1139 test/daemon-util_unittest.bash: daemons/daemon-util
1140
1141 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1142
1143 test/bash_completion.bash: doc/examples/bash_completion-debug
1144
1145 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1146         sed -f $(REPLACE_VARS_SED) < $< > $@
1147         chmod +x $@
1148
1149 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1150         sed -f $(REPLACE_VARS_SED) < $< > $@
1151         chmod +x $@
1152
1153 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1154         sed -f $(REPLACE_VARS_SED) < $< > $@
1155         chmod +x $@
1156
1157 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1158         sed -f $(REPLACE_VARS_SED) < $< > $@
1159
1160 doc/examples/bash_completion: BC_ARGS = --compact
1161 doc/examples/bash_completion-debug: BC_ARGS =
1162
1163 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1164         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1165         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1166         daemons/ganeti-cleaner \
1167         $(GENERATED_FILES) $(HTOOLS_GENERATED_FILES)
1168         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1169           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1170
1171 doc/%.png: doc/%.dot
1172         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
1173         $(DOT) -Tpng -o $@ $<
1174
1175 man/footer.man: man/footer.rst
1176         @test -n "$(PANDOC)" || \
1177           { echo 'pandoc' not found during configure; exit 1; }
1178         $(PANDOC) -f rst -t man -o $@ $<
1179
1180 man/footer.html: man/footer.rst
1181         @test -n "$(PANDOC)" || \
1182           { echo 'pandoc' not found during configure; exit 1; }
1183         $(PANDOC) -f rst -t html -o $@ $<
1184
1185 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1186         lib/build/shell_example_lexer.py \
1187         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1188         @echo "Checking $< for hardcoded paths..."
1189         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1190           echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1191           exit 1; \
1192         fi
1193         set -e ; \
1194         trap 'echo auto-removing $@; rm $@' EXIT; \
1195         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1196         trap - EXIT
1197
1198 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1199         @test -n "$(PANDOC)" || \
1200           { echo 'pandoc' not found during configure; exit 1; }
1201         set -o pipefail ; \
1202         trap 'echo auto-removing $@; rm $@' EXIT; \
1203         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1204           sed -e 's/\\@/@/g' > $@; \
1205         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1206         $(CHECK_MAN_DASHES) $@; \
1207         trap - EXIT
1208
1209
1210 man/%.html.in: man/%.gen man/footer.html
1211         @test -n "$(PANDOC)" || \
1212           { echo 'pandoc' not found during configure; exit 1; }
1213         set -o pipefail ; \
1214         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1215           sed -e 's/\\@/@/g' > $@
1216
1217 man/%: man/%.in  $(REPLACE_VARS_SED)
1218         sed -f $(REPLACE_VARS_SED) < $< > $@
1219
1220 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1221         sed -f $(REPLACE_VARS_SED) < $< > $@
1222
1223 vcs-version:
1224         if test -d .git; then \
1225           git describe > $@; \
1226         elif test ! -f $@ ; then \
1227           echo "Cannot auto-generate $@ file"; exit 1; \
1228         fi
1229
1230 .PHONY: clean-vcs-version
1231 clean-vcs-version:
1232         rm -f vcs-version
1233
1234 .PHONY: regen-vcs-version
1235 regen-vcs-version:
1236         @set -e; \
1237         cd $(srcdir); \
1238         if test -d .git; then \
1239           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1240           git describe > $$T; \
1241           if ! cmp --quiet $$T vcs-version; then \
1242             mv $$T vcs-version; \
1243           fi; \
1244         fi
1245
1246 htools/Ganeti/Version.hs: htools/Ganeti/Version.hs.in \
1247         vcs-version $(built_base_sources)
1248         set -e; \
1249         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1250         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1251
1252 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1253         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1254         lib/jstore.py \
1255         $(CONVERT_CONSTANTS) $(built_base_sources) \
1256         | lib/_vcsversion.py
1257         set -e; \
1258         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1259
1260 htest/Test/Ganeti/TestImports.hs: htest/Test/Ganeti/TestImports.hs.in \
1261         $(built_base_sources)
1262         set -e; \
1263         { cat $< ; \
1264           echo ; \
1265           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst htools/%,%,$(HS_LIB_SRCS))))) ; do \
1266             echo "import $$name ()" ; \
1267           done ; \
1268         } > $@
1269
1270 lib/_autoconf.py: Makefile | stamp-directories
1271         set -e; \
1272         { echo '# This file is automatically generated, do not edit!'; \
1273           echo '#'; \
1274           echo ''; \
1275           echo '"""Build-time configuration for Ganeti.'; \
1276           echo '';\
1277           echo 'This file is autogenerated by the build process.'; \
1278           echo 'For any changes you need to re-run ./configure (and'; \
1279           echo 'not edit by hand).'; \
1280           echo ''; \
1281           echo '"""'; \
1282           echo ''; \
1283           echo '# pylint: disable=C0301,C0324'; \
1284           echo '# because this is autogenerated, we do not want'; \
1285           echo '# style warnings' ; \
1286           echo ''; \
1287           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1288           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1289           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1290           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1291           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1292           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1293           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1294           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1295           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1296           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1297           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1298           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1299           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1300           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1301           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1302           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1303           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1304           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1305           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1306           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1307           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1308           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1309           echo "KVM_PATH = '$(KVM_PATH)'"; \
1310           echo "IP_PATH = '$(IP_PATH)'"; \
1311           echo "SOCAT_PATH = '$(SOCAT)'"; \
1312           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1313           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1314           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1315           echo "TOOLSDIR = '$(toolsdir)'"; \
1316           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1317           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1318           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1319           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1320           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1321           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1322           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1323           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1324           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1325           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1326           echo "RAPI_USER = '$(RAPI_USER)'"; \
1327           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1328           echo "CONFD_USER = '$(CONFD_USER)'"; \
1329           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1330           echo "NODED_USER = '$(NODED_USER)'"; \
1331           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1332           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1333           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1334           echo "HTOOLS = True"; \
1335           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1336           echo "XEN_CMD = '$(XEN_CMD)'"; \
1337           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1338           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1339           echo "ENABLE_MONITORING = $(ENABLE_MONITORING)"; \
1340         } > $@
1341
1342 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1343         set -e; \
1344         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1345         { echo '# This file is automatically generated, do not edit!'; \
1346           echo '#'; \
1347           echo ''; \
1348           echo '"""Build-time VCS version number for Ganeti.'; \
1349           echo '';\
1350           echo 'This file is autogenerated by the build process.'; \
1351           echo 'For any changes you need to re-run ./configure (and'; \
1352           echo 'not edit by hand).'; \
1353           echo ''; \
1354           echo '"""'; \
1355           echo ''; \
1356           echo '# pylint: disable=C0301,C0324'; \
1357           echo '# because this is autogenerated, we do not want'; \
1358           echo '# style warnings' ; \
1359           echo ''; \
1360           echo "VCS_VERSION = '$$VCSVER'"; \
1361         } > $@
1362
1363 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1364         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1365
1366 $(SHELL_ENV_INIT): Makefile stamp-directories
1367         set -e; \
1368         { echo '# Allow overriding for tests'; \
1369           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1370           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1371           echo; \
1372           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1373           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1374           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1375           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1376           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1377         } > $@
1378
1379 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1380         set -e; \
1381         { echo 's#@PREFIX@#$(prefix)#g'; \
1382           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1383           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1384           echo 's#@BINDIR@#$(bindir)#g'; \
1385           echo 's#@SBINDIR@#$(sbindir)#g'; \
1386           echo 's#@LIBDIR@#$(libdir)#g'; \
1387           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1388           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1389           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1390           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1391           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1392           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1393           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1394           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1395           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1396           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1397           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1398           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1399           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1400           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1401           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1402           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1403           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1404           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1405           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1406           echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
1407           echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
1408           echo; \
1409           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1410           echo '  r $(SHELL_ENV_INIT)'; \
1411           echo '  d'; \
1412           echo '}'; \
1413         } > $@
1414
1415 # Using deferred evaluation
1416 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1417 daemons/ganeti-watcher: MODULE = ganeti.watcher
1418 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1419 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1420 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1421 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1422 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1423 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst htest/%,%,$@)
1424
1425 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1426         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1427         set -e; \
1428         { echo '#!/usr/bin/python'; \
1429           echo '# This file is automatically generated, do not edit!'; \
1430           echo "# Edit $(MODULE) instead."; \
1431           echo; \
1432           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1433           echo; \
1434           echo '# pylint: disable=C0103'; \
1435           echo '# C0103: Invalid name'; \
1436           echo; \
1437           echo 'import sys'; \
1438           echo 'import $(MODULE) as main'; \
1439           echo; \
1440           echo '# Temporarily alias commands until bash completion'; \
1441           echo '# generator is changed'; \
1442           echo 'if hasattr(main, "commands"):'; \
1443           echo '  commands = main.commands # pylint: disable=E1101'; \
1444           echo 'if hasattr(main, "aliases"):'; \
1445           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1446           echo; \
1447           echo 'if __name__ == "__main__":'; \
1448           echo '  sys.exit(main.Main())'; \
1449         } > $@
1450         chmod u+x $@
1451
1452 $(HS_BUILT_TEST_HELPERS): Makefile
1453         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1454         set -e; \
1455         { echo '#!/bin/sh'; \
1456           echo '# This file is automatically generated, do not edit!'; \
1457           echo "# Edit Makefile.am instead."; \
1458           echo; \
1459           echo "HTOOLS=$(TESTROLE) exec ./htest/hpc-htools \"\$$@\""; \
1460         } > $@
1461         chmod u+x $@
1462
1463 stamp-directories: Makefile
1464         $(MAKE) $(AM_MAKEFLAGS) ganeti
1465         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1466         touch $@
1467
1468 # We need to create symlinks because "make distcheck" will not install Python
1469 # files when building.
1470 stamp-srclinks: Makefile | stamp-directories
1471         set -e; \
1472         for i in $(srclink_files); do \
1473           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1474             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1475           fi; \
1476         done
1477         touch $@
1478
1479 .PHONY: ganeti
1480 ganeti:
1481         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1482
1483 .PHONY: check-dirs
1484 check-dirs: $(GENERATED_FILES)
1485         @set -e; \
1486         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1487           error=; \
1488           while read dir; do \
1489             case "$$dir" in \
1490               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1491               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1492             esac; \
1493           done; \
1494           for dir in $(DIRS); do \
1495             if ! test -d "$$dir"; then \
1496               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1497               error=1; \
1498             fi \
1499           done; \
1500           test -z "$$error"; \
1501         }
1502
1503 .PHONY: check-local
1504 check-local: check-dirs $(GENERATED_FILES)
1505         $(CHECK_PYTHON_CODE) $(check_python_code)
1506         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1507         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1508         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1509         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1510         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1511         error= ; \
1512         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1513           echo "Incorrect version in README, expected $$expver" >&2; \
1514           error=1; \
1515         fi; \
1516         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1517             doc/security.rst; do \
1518           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1519             "Documents Ganeti version $$expver"; then \
1520             echo "Incorrect version in $$file, expected $$expver" >&2; \
1521             error=1; \
1522           fi; \
1523         done; \
1524         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1525           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1526           error=1; \
1527         fi; \
1528         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1529           ".. Last updated for Ganeti $$expver"; then \
1530           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1531           error=1; \
1532         fi; \
1533         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1534           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1535             echo "Longest line in $$file is longer than 80 characters" >&2; \
1536             error=1; \
1537           fi; \
1538         done; \
1539         test -z "$$error"
1540
1541 .PHONY: hs-check
1542 hs-check: htest/test htest/hpc-htools htest/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1543         @rm -f *.tix
1544         ./htest/test
1545         HBINARY="./htest/hpc-htools" ./htest/offline-test.sh
1546
1547 # E111: indentation is not a multiple of four
1548 # E121: continuation line indentation is not a multiple of four
1549 #       (since our indent level is not 4)
1550 # E125: continuation line does not distinguish itself from next logical line
1551 #       (since our indent level is not 4)
1552 # E127: continuation line over-indented for visual indent
1553 #       (since our indent level is not 4)
1554 # note: do NOT add E128 here; it's a valid style error in most cases!
1555 # I've seen real errors, but also some cases were we indent wrongly
1556 # due to line length; try to rework the cases where it is triggered,
1557 # instead of silencing it
1558 # E261: at least two spaces before inline comment
1559 # E501: line too long (80 characters)
1560 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1561
1562 # For excluding pep8 expects filenames only, not whole paths
1563 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1564
1565 LINT_TARGETS = pylint pylint-qa
1566 if HAS_PEP8
1567 LINT_TARGETS += pep8
1568 endif
1569 if HAS_HLINT
1570 LINT_TARGETS += hlint
1571 endif
1572
1573 .PHONY: lint
1574 lint: $(LINT_TARGETS)
1575
1576 .PHONY: pylint
1577 pylint: $(GENERATED_FILES)
1578         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1579         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1580
1581 .PHONY: pylint-qa
1582 pylint-qa: $(GENERATED_FILES)
1583         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1584         cd $(top_srcdir)/qa && \
1585           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1586           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1587
1588 .PHONY: pep8
1589 pep8: $(GENERATED_FILES)
1590         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1591         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1592           --repeat $(pep8_python_code)
1593
1594 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1595 HLINT_EXCLUDES = htools/Ganeti/THH.hs htest/hpc-htools.hs
1596 .PHONY: hlint
1597 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1598         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1599         if tty -s; then C="-c"; else C=""; fi; \
1600         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1601           --ignore "Use first" \
1602           --ignore "Use &&&" \
1603           --ignore "Use void" \
1604           --ignore "Reduce duplication" \
1605           --hint htools/lint-hints \
1606           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1607
1608 # a dist hook rule for updating the vcs-version file; this is
1609 # hardcoded due to where it needs to build the file...
1610 dist-hook:
1611         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1612         rm -f $(top_distdir)/vcs-version
1613         cp -p $(srcdir)/vcs-version $(top_distdir)
1614
1615 # a distcheck hook rule for catching revision control directories
1616 distcheck-hook:
1617         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1618           echo "Found revision control files in final archive." 1>&2; \
1619           exit 1; \
1620         fi
1621         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1622           echo "Found Python byte code in final archive." 1>&2; \
1623           exit 1; \
1624         fi
1625         if find $(top_distdir) -name '*~' | grep .; then \
1626           echo "Found backup files in final archive." 1>&2; \
1627           exit 1; \
1628         fi
1629 # Empty files or directories should not be distributed. They can cause
1630 # unnecessary warnings for packagers. Directories used by automake during
1631 # distcheck must be excluded.
1632         if find $(top_distdir) -empty -and -not \( \
1633             -path $(top_distdir)/_build -or \
1634             -path $(top_distdir)/_inst \) | grep .; then \
1635           echo "Found empty files or directories in final archive." 1>&2; \
1636           exit 1; \
1637         fi
1638         if test -n "$(BUILD_RELEASE)" && \
1639            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1640            echo "Found unreleased version in NEWS." >&2; \
1641            exit 1; \
1642         fi
1643
1644 # When building a release, stricter checks should be used
1645 distcheck-release dist-release: export BUILD_RELEASE = 1
1646 distcheck-release: distcheck
1647
1648 distrebuildcheck: dist
1649         set -e; \
1650         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1651         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1652         cd $$builddir; \
1653         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1654         cd $(distdir); \
1655         ./configure; \
1656         $(MAKE) maintainer-clean; \
1657         cp $(abs_srcdir)/vcs-version .; \
1658         ./configure; \
1659         $(MAKE) $(AM_MAKEFLAGS)
1660
1661 dist-release: dist
1662         set -e; \
1663         for i in $(DIST_ARCHIVES); do \
1664           echo -n "Checking $$i ... "; \
1665           autotools/check-tar < $$i; \
1666           echo OK; \
1667         done
1668
1669 install-exec-local:
1670         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1671           "$(DESTDIR)${localstatedir}/log/ganeti" \
1672           "$(DESTDIR)${localstatedir}/run/ganeti"
1673
1674 .PHONY: apidoc
1675 if WANT_HTOOLSAPIDOC
1676 apidoc: py-apidoc hs-apidoc
1677 else
1678 apidoc: py-apidoc
1679 endif
1680
1681 .PHONY: py-apidoc
1682 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1683         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1684         $(RUN_IN_TEMPDIR) epydoc -v \
1685           --conf $(CURDIR)/epydoc.conf \
1686           --output $(CURDIR)/$(APIDOC_PY_DIR)
1687
1688 .PHONY: hs-apidoc
1689 hs-apidoc: $(HS_BUILT_SRCS)
1690         @test -n "$(HSCOLOUR)" || \
1691             { echo 'HsColour' not found during configure; exit 1; }
1692         @test -n "$(HADDOCK)" || \
1693             { echo 'haddock' not found during configure; exit 1; }
1694         rm -rf $(APIDOC_HS_DIR)/*
1695         for i in $(ALL_APIDOC_HS_DIRS); do \
1696           @mkdir_p@ $$i; \
1697         done
1698         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1699         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1700         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1701         set -e ; \
1702         cd htools; \
1703         if [ "$(HTOOLS_NOCURL)" ]; \
1704         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1705         else OPTGHC=""; \
1706         fi; \
1707         if [ "$(HTOOLS_PARALLEL3)" ]; \
1708         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1709         fi; \
1710         if [ "$(HTOOLS_REGEX_PCRE)" ]; \
1711         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_REGEX_PCRE)"; \
1712         fi; \
1713         RELSRCS="$(HS_LIB_SRCS:htools/%=%) $(patsubst htools/%,%,$(filter htools/%,$(HS_BUILT_SRCS)))"; \
1714         for file in $$RELSRCS; do \
1715           hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1716           $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1717         done ; \
1718         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1719           -t ganeti -p haddock-prologue \
1720           --source-module="%{MODULE/.//}.html" \
1721           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1722           $$OPTGHC \
1723           $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1724
1725 .PHONY: TAGS
1726 TAGS: $(GENERATED_FILES)
1727         rm -f TAGS
1728         $(GHC) -e ":etags" -v0 \
1729           $(filter-out -O -Werror,$(HFLAGS)) \
1730           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
1731           $(HS_LIBTEST_SRCS)
1732         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1733           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1734           -path './qa/*.py' | \
1735           etags -l python -a -
1736
1737 .PHONY: coverage
1738 if WANT_HTOOLS
1739 coverage: py-coverage hs-coverage
1740 else
1741 coverage: py-coverage
1742 endif
1743
1744 .PHONY: py-coverage
1745 py-coverage: $(GENERATED_FILES) $(python_tests)
1746         @test -n "$(PYCOVERAGE)" || \
1747             { echo 'python-coverage' not found during configure; exit 1; }
1748         set -e; \
1749         COVERAGE=$(PYCOVERAGE) \
1750         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1751         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1752         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1753         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1754         $(python_tests)
1755
1756 .PHONY: hs-coverage
1757 hs-coverage: $(haskell_tests) htest/hpc-htools htest/hpc-mon-collector
1758         rm -f *.tix
1759         $(MAKE) $(AM_MAKEFLAGS) hs-check
1760         @mkdir_p@ $(COVERAGE_HS_DIR)
1761         hpc sum --union $(HPCEXCL) \
1762           test.tix hpc-htools.tix hpc-mon-collector.tix > coverage-htools.tix
1763         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1764         hpc report coverage-htools.tix
1765         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1766
1767 # Special "kind-of-QA" target for htools, needs special setup (all
1768 # tools compiled with -fhpc)
1769 .PHONY: live-test
1770 live-test: all
1771         set -e ; \
1772         cd htools; \
1773         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1774         rm -f *.tix *.mix; \
1775         ./live-test.sh; \
1776         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1777           --output=live-test.tix ; \
1778         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1779         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1780           --srcdir=.. $(HPCEXCL) ; \
1781         hpc report --srcdir=.. live-test $(HPCEXCL)
1782
1783 commit-check: distcheck lint apidoc
1784
1785 .PHONY: gitignore-check
1786 gitignore-check:
1787         @if [ -n "`git status --short`" ]; then \
1788           echo "Git status is not clean!" 1>&2 ; \
1789           git status --short; \
1790           exit 1; \
1791         fi
1792
1793 # Target that builds all binaries (including those that are not
1794 # rebuilt except when running the tests)
1795 .PHONY: really-all
1796 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1797
1798 # we don't need the ancient implicit rules:
1799 %: %,v
1800 %: RCS/%,v
1801 %: RCS/%
1802 %: s.%
1803 %: SCCS/s.%
1804
1805 -include ./Makefile.local
1806
1807 # vim: set noet :